package com.steerinfo.TimedTask.rsbcread.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.TimedTask.rsbcread.model.RsBcread;
import com.steerinfo.TimedTask.rsbcread.service.IRsBcreadService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.math.BigDecimal;

/**
 * RsBcread RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-10-28 07:23
 * 类描述
 * 修订历史：
 * 日期：2021-10-28
 * 作者：generator
 * 参考：
 * 描述：RsBcread RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/rsbcreads")
public class RsBcreadController extends BaseRESTfulController {

    @Autowired
    IRsBcreadService rsBcreadService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("rsbcread:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<RsBcread> list = rsBcreadService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("rsbcread:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<RsBcread> list = rsBcreadService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据RsBcread对象创建")
    @ApiImplicitParam(name = "rsBcread", value = "详细实体rsBcread", required = true, dataType = "RsBcread")
    //@RequiresPermissions("rsbcread:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute RsBcread model){
        RsBcread rsBcread = rsBcreadService.add(model);
        return success(rsBcread);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "BigDecimal")
    //@RequiresPermissions("rsbcread:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable BigDecimal id){
        RsBcread rsBcread = rsBcreadService.getById(id);
        return success(rsBcread);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的rsBcread信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "BigDecimal"),
        @ApiImplicitParam(name = "rsBcread", value = "详细实体rsBcread", required = true, dataType = "RsBcread")
    })
    //@RequiresPermissions("rsbcread:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable BigDecimal id, @RequestBody RsBcread model){
        model.setId(id);
        RsBcread rsBcread = rsBcreadService.modify(model);
        return success(rsBcread);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "BigDecimal")
    //@RequiresPermissions("rsbcread:delete")
    @DeleteMapping(value = "/{id}")//BigDecimal
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<BigDecimal> ids = ListUtils.convertList(list);
			  rsBcreadService.delete(ids);
    	}
      return success();
    }
}
